Gerador de hash: MD5, SHA-1, SHA-256

Digite um texto para ver seus resumos MD5, SHA-1, SHA-256, SHA-384 e SHA-512 em hexadecimal. Acrescente uma chave e cada linha vira um HMAC, uma assinatura feita com um segredo.

Gratuita Funciona no seu navegador Verificada em terça-feira, 10 de novembro de 2026

O texto a calcular, como bytes UTF-8. Letras como ç ou ã ocupam dois bytes cada.

Deixe vazio para resumos simples. Com uma chave, cada linha é um HMAC feito com essa chave.

Resultado

Resumos

Esta ferramenta funciona no seu navegador. O que você digita não é enviado para nós.

Como usar

  1. Digite ou cole o texto em Texto.
  2. Deixe Chave (opcional) vazio para resumos simples, ou digite uma chave para obter HMACs.
  3. Copie um resumo da sua linha, ou use Exportar como CSV para guardar a tabela inteira.
  4. Confira o algoritmo da primeira coluna com o que o seu sistema ou documento pede.

O que é um hash

Uma função hash transforma qualquer texto em um código de tamanho fixo, chamado resumo. O mesmo texto sempre dá o mesmo resumo, uma pequena mudança dá um resumo completamente diferente, e o resumo não pode ser transformado de volta no texto. Aqui os resumos são escritos em hexadecimal: o MD5 tem 32 dígitos, o SHA-1 tem 40, o SHA-256 tem 64, o SHA-384 tem 96 e o SHA-512 tem 128.

Dígitos hexadecimais = bits ÷ 4

MD5      128 ÷ 4 = 32
SHA-256  256 ÷ 4 = 64
SHA-512  512 ÷ 4 = 128

Qual algoritmo usar

MD5 e SHA-1 estão quebrados. Dois textos diferentes podem ser encontrados com o mesmo resumo, então não devem ser usados em assinaturas ou certificados. Eles ainda aparecem em sistemas antigos e como uma verificação rápida contra danos acidentais em um download. SHA-256 e SHA-512 pertencem ao padrão atual, o FIPS 180-4, e são a escolha usual.

Para guardar senhas, use uma função de hash de senhas, como Argon2 ou bcrypt. Nenhum dos resumos desta página serve para isso.

HMAC: um resumo com chave

Um HMAC (RFC 2104) combina uma chave com um hash de um modo fixo. Só quem conhece a chave consegue fazer o mesmo HMAC, então ele mostra que uma mensagem veio de um remetente conhecido e não foi alterada no caminho. A página calcula HMACs com os mesmos algoritmos dos resumos simples.

Texto são bytes

  • O texto é calculado como bytes UTF-8 (RFC 3629). Letras ASCII ocupam um byte, letras como ç e ã ocupam dois, e um emoji ocupa quatro.
  • Um final de linha diferente, uma codificação diferente ou um espaço a mais dão outro resumo, então calcule os mesmos bytes que a outra ferramenta.

Exemplo resolvido: abc e um HMAC

Os resumos do texto abc são valores publicados: o MD5 na RFC 1321, e o SHA-1, o SHA-256, o SHA-384 e o SHA-512 no FIPS 180-4.

Com a chave Jefe e o texto what do ya want for nothing?, o HMAC-SHA-256 é 5bdcc146bf60754e6a042426089575c75a003f089d2739839dec58b964ec3843, o valor de teste da RFC 4231, caso de teste 2.

Algoritmo Resumo de abc
MD5 900150983cd24fb0d6963f7d28e17f72
SHA-1 a9993e364706816aba3e25717850c26c9cd0d89d
SHA-256 ba7816bf8f01cfea414140de5dae2223b00361a396177a9cb410ff61f20015ad
SHA-384 cb00753f45a35e8bb5a03d699ac65007272c32ab0eded1631a8b605a43ff5bed8086072ba1e7cc2358baeca134c825a7
SHA-512 ddaf35a193617abacc417349ae20413112e6fa4e89a97ea20a9eeee64b55d39a2192992a274fc1a836ba3c23a3feebbd454d4423643ce80e2a9ac94fa54ca49f

Perguntas frequentes

O MD5 é seguro para senhas?

Não. O MD5 é rápido e está quebrado, então uma lista vazada de hashes de senha em MD5 é fácil de quebrar. Guarde senhas com uma função de hash de senhas, como Argon2 ou bcrypt.

O SHA-256 é o mesmo que criptografia?

Não. Um hash é de mão única: não pode ser transformado de volta no texto, e não usa chave. A criptografia pode ser revertida com a chave certa. Use um hash para verificar a integridade, e um HMAC para verificar se uma mensagem veio de quem conhece a chave.

Qual é a diferença entre um hash e um HMAC?

Um hash depende só do texto. Um HMAC também precisa de uma chave secreta, então só quem tem a chave pode criá-lo ou verificá-lo. As assinaturas de webhooks e de APIs costumam ser HMAC-SHA-256.

Por que meus resumos diferem de outra ferramenta?

Os bytes precisam ser os mesmos. Um final de linha diferente, uma codificação diferente como Windows-1252, ou um espaço a mais muda todos os resumos. Calcule os mesmos bytes que a outra ferramenta calcula.

O meu texto é enviado para algum lugar?

Não. Os resumos são calculados no seu navegador, e o texto não é enviado nem guardado.

Posso verificar um arquivo com esta ferramenta?

Esta página calcula hash só de texto. Para um arquivo, use a ferramenta de checksum do seu sistema operacional ou o checksum que o site de download publica.

Fontes

Números e texto verificados pela última vez em terça-feira, 10 de novembro de 2026.

Usamos cookies necessários para o site funcionar. Com o seu consentimento, o Google também usa cookies de publicidade para mostrar anúncios personalizados. Se você recusá-los, continuará vendo anúncios, mas eles não serão personalizados.